/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.math.BigDecimal;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.api.Timebox;

import com.rjconsultores.ventaboletos.entidad.CategoriaDescuento;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 * 
 * @author rodrigo
 */
@Controller("editarConfiguracionCategoriaDatosCategoriaController")
@Scope("prototype")
public class EditarConfiguracionCategoriaDatosCategoriaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private CategoriaDescuento categoriaDescuento;
	private MyListbox categoriaDescuentoList;
	private Radio radioImp;
	private Radio radioPor;
	private Radio radioImprimePassagem;
	private Radio radioNaoImprimePassagem;
	private Textbox descuentoPorc;
	private Textbox descuentoImporte;
	private Row rowTrecho;
	private Row rowTiempo;
	private Timebox timeTempoPermitir;
	private Radio rdCuotaSi;
	private Radio rdTrecho;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		categoriaDescuentoList = (MyListbox) Executions.getCurrent().getArg().get("categoriaDescuentoList");
		categoriaDescuento = (CategoriaDescuento) Executions.getCurrent().getArg().get("categoriaDescuento");

		super.doAfterCompose(comp);

		if ((categoriaDescuento.getDescuentoimporte() != null) && (!categoriaDescuento.getDescuentoimporte().equals(BigDecimal.ZERO))) {
			radioImp.setSelected(true);
			descuentoPorc.setDisabled(true);
		}

		if ((categoriaDescuento.getDescuentoporc() != null) && (!categoriaDescuento.getDescuentoporc().equals(BigDecimal.ZERO))) {
			radioPor.setSelected(true);
			descuentoImporte.setDisabled(true);
		}

		if ((categoriaDescuento.getIndImprimeBoleto() != null) && (categoriaDescuento.getIndImprimeBoleto())) {
			radioImprimePassagem.setSelected(Boolean.TRUE);
		} else if ((categoriaDescuento.getIndImprimeBoleto() != null) && (!categoriaDescuento.getIndImprimeBoleto())) {
			radioNaoImprimePassagem.setSelected(Boolean.TRUE);
		}
		
		if ( (categoriaDescuento.getIndCuota() != null) && (categoriaDescuento.getIndCuota()) ){
			mudarCamposCuota(true);
			timeTempoPermitir.setValue(categoriaDescuento.getTiempoCuota());
			rdCuotaSi.setChecked(true);
			rdTrecho.setChecked(categoriaDescuento.getIndCuotaTramo());
		}else{
			mudarCamposCuota(false);
		}
	}

	public void onClick$btnSalvar(Event ev) {
		if (radioImprimePassagem.isSelected()) {
			categoriaDescuento.setIndImprimeBoleto(Boolean.TRUE);
		} else if (radioNaoImprimePassagem.isSelected()) {
			categoriaDescuento.setIndImprimeBoleto(Boolean.FALSE);
		}
		
		categoriaDescuento.setIndCuota(false);
		categoriaDescuento.setIndCuotaTramo(false);
		
		if (rdCuotaSi.isChecked()){
			if (timeTempoPermitir.getValue() == null){
				throw new WrongValueException(timeTempoPermitir, Labels.getLabel("MSG.CONSTRAINT.CONSTRAINTNUMBERBDOBLIGATORIO"));
			}
			
			categoriaDescuento.setIndCuota(true);
			categoriaDescuento.setIndCuotaTramo(rdTrecho.isChecked());
			categoriaDescuento.setTiempoCuota(timeTempoPermitir.getValue());
		}

		categoriaDescuentoList.updateItem(categoriaDescuento);
		this.closeWindow();
	}

	public CategoriaDescuento getCategoriaDescuento() {
		return categoriaDescuento;
	}

	public void setCategoriaDescuento(CategoriaDescuento categoriaDescuento) {
		this.categoriaDescuento = categoriaDescuento;
	}

	public void onClick$radioImp(Event ev) {
		descuentoPorc.setDisabled(true);
		descuentoImporte.setDisabled(false);

		descuentoPorc.setConstraint("");
		descuentoPorc.setValue("0");
		categoriaDescuento.setDescuentoporc(BigDecimal.ZERO);
		descuentoImporte.setConstraint("no empty, no negative");
	}

	public void onClick$radioPor(Event ev) {
		descuentoImporte.setDisabled(true);
		descuentoPorc.setDisabled(false);

		descuentoImporte.setConstraint("");
		descuentoImporte.setValue("0");
		categoriaDescuento.setDescuentoimporte(BigDecimal.ZERO);
		descuentoPorc.setConstraint("no empty, no zero, no negative");
	}
	
	public void onClick$rdCuotaSi(Event ev) {
		mudarCamposCuota(true);
	}
	
	private void mudarCamposCuota(boolean visible){
		rowTrecho.setVisible(visible);
		rowTiempo.setVisible(visible);
		
		timeTempoPermitir.setValue(null);
	}
	public void onClick$rdCuotaNo(Event ev) {
		mudarCamposCuota(false);
	}
}
